﻿
'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by a tool.
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------

Option Strict On
Option Explicit On

Imports __Product = LightSwitchApplication.Product

Namespace LightSwitchApplication

    #Region "Entities"
    
    ''' <summary>
    ''' No Modeled Description Available
    ''' </summary>
    <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
    Public NotInheritable Partial Class Product
        Inherits Global.Microsoft.LightSwitch.Framework.Base.EntityObject(Of __Product, __Product.DetailsClass)
    
        #Region "Constructors"
    
        ''' <summary>
        ''' Initializes a new instance of the Product entity.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Sub New()
            Me.New(Nothing)
        End Sub
    
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Sub New(entitySet As Global.Microsoft.LightSwitch.Framework.EntitySet(Of __Product))
            MyBase.New(entitySet)
            
            __Product.DetailsClass.Initialize(Me)
        End Sub
    
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Product_Created()
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Product_AllowSaveWithErrors(ByRef result As Boolean)
        End Sub
    
        #End Region
    
        #Region "Private Properties"
        
        ''' <summary>
        ''' Gets the Application object for this application.  The Application object provides access to active screens, methods to open screens and access to the current user.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Private ReadOnly Property Application As Global.Microsoft.LightSwitch.IApplication(Of Global.LightSwitchApplication.DataWorkspace)
            Get
                Return Global.LightSwitchApplication.Application.Current
            End Get
        End Property
        
        ''' <summary>
        ''' Gets the containing data workspace.  The data workspace provides access to all data sources in the application.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Private ReadOnly Property DataWorkspace As Global.LightSwitchApplication.DataWorkspace
            Get
                Return DirectCast(Me.Details.EntitySet.Details.DataService.Details.DataWorkspace, Global.LightSwitchApplication.DataWorkspace)
            End Get
        End Property
        
        #End Region
    
        #Region "Public Properties"
    
        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Id As Integer
            Get
                Return __Product.DetailsClass.GetValue(Me, __Product.DetailsClass.PropertySetProperties.Id)
            End Get
            Set
                __Product.DetailsClass.SetValue(Me, __Product.DetailsClass.PropertySetProperties.Id, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property RowVersion As Byte()
            Get
                Return __Product.DetailsClass.GetValue(Me, __Product.DetailsClass.PropertySetProperties.RowVersion)
            End Get
            Set
                __Product.DetailsClass.SetValue(Me, __Product.DetailsClass.PropertySetProperties.RowVersion, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property ProductName As String
            Get
                Return __Product.DetailsClass.GetValue(Me, __Product.DetailsClass.PropertySetProperties.ProductName)
            End Get
            Set
                __Product.DetailsClass.SetValue(Me, __Product.DetailsClass.PropertySetProperties.ProductName, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ProductName_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ProductName_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ProductName_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Price As Decimal
            Get
                Return __Product.DetailsClass.GetValue(Me, __Product.DetailsClass.PropertySetProperties.Price)
            End Get
            Set
                __Product.DetailsClass.SetValue(Me, __Product.DetailsClass.PropertySetProperties.Price, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Price_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Price_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Price_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Tax As Global.LightSwitchApplication.Tax
            Get
                Return __Product.DetailsClass.GetValue(Me, __Product.DetailsClass.PropertySetProperties.Tax)
            End Get
            Set
                __Product.DetailsClass.SetValue(Me, __Product.DetailsClass.PropertySetProperties.Tax, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Tax_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Tax_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Tax_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property InventoryHeaders As Global.Microsoft.LightSwitch.Framework.EntityCollection(Of Global.LightSwitchApplication.InventoryHeader)
            Get
                Return __Product.DetailsClass.GetValue(Me, __Product.DetailsClass.PropertySetProperties.InventoryHeaders)
            End Get
        End Property
        
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property InventoryHeadersQuery As Microsoft.LightSwitch.IDataServiceQueryable(Of Global.LightSwitchApplication.InventoryHeader)
            Get
                Return __Product.DetailsClass.GetQuery(Me, __Product.DetailsClass.PropertySetProperties.InventoryHeaders)
            End Get
        End Property

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property InvoiceDetails As Global.Microsoft.LightSwitch.Framework.EntityCollection(Of Global.LightSwitchApplication.InvoiceDetail)
            Get
                Return __Product.DetailsClass.GetValue(Me, __Product.DetailsClass.PropertySetProperties.InvoiceDetails)
            End Get
        End Property
        
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property InvoiceDetailsQuery As Microsoft.LightSwitch.IDataServiceQueryable(Of Global.LightSwitchApplication.InvoiceDetail)
            Get
                Return __Product.DetailsClass.GetQuery(Me, __Product.DetailsClass.PropertySetProperties.InvoiceDetails)
            End Get
        End Property

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property SalesOrderDetails As Global.Microsoft.LightSwitch.Framework.EntityCollection(Of Global.LightSwitchApplication.SalesOrderDetail)
            Get
                Return __Product.DetailsClass.GetValue(Me, __Product.DetailsClass.PropertySetProperties.SalesOrderDetails)
            End Get
        End Property
        
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property SalesOrderDetailsQuery As Microsoft.LightSwitch.IDataServiceQueryable(Of Global.LightSwitchApplication.SalesOrderDetail)
            Get
                Return __Product.DetailsClass.GetQuery(Me, __Product.DetailsClass.PropertySetProperties.SalesOrderDetails)
            End Get
        End Property

        #End Region
    
        #Region "Details Class"
    
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
        <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public NotInheritable Class DetailsClass
            Inherits Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of _
                __Product, _
                __Product.DetailsClass, _
                __Product.DetailsClass.IImplementation, _
                __Product.DetailsClass.PropertySet, _
                Global.Microsoft.LightSwitch.Details.Framework.EntityCommandSet(Of __Product, __Product.DetailsClass), _
                Global.Microsoft.LightSwitch.Details.Framework.EntityMethodSet(Of __Product, __Product.DetailsClass))
    
            Shared Sub New()
                Dim initializeEntry = __Product.DetailsClass.PropertySetProperties.Id
            End Sub
    
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private Shared ReadOnly __ProductEntry As Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of __Product, __Product.DetailsClass).Entry = _
                New Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of __Product, __Product.DetailsClass).Entry( _
                    AddressOf __Product.DetailsClass.__Product_CreateNew, _
                    AddressOf __Product.DetailsClass.__Product_Created, _
                    AddressOf __Product.DetailsClass.__Product_AllowSaveWithErrors)
            Private Shared Function __Product_CreateNew(es As Global.Microsoft.LightSwitch.Framework.EntitySet(Of __Product)) As __Product
                Return New __Product(es)
            End Function
            Private Shared Sub __Product_Created(e As __Product)
                e.Product_Created()
            End Sub
            Private Shared Function __Product_AllowSaveWithErrors(e As __Product) As Boolean
                Dim result As Boolean = False
                e.Product_AllowSaveWithErrors(result)
                Return result
            End Function
    
            Public Sub New()
                MyBase.New()
            End Sub
    
            Public ReadOnly Shadows Property Commands As Global.Microsoft.LightSwitch.Details.Framework.EntityCommandSet(Of __Product, __Product.DetailsClass)
                Get
                    Return MyBase.Commands
                End Get
            End Property
    
            Public ReadOnly Shadows Property Methods As Global.Microsoft.LightSwitch.Details.Framework.EntityMethodSet(Of __Product, __Product.DetailsClass)
                Get
                    Return MyBase.Methods
                End Get
            End Property
    
            Public ReadOnly Shadows Property Properties As __Product.DetailsClass.PropertySet
                Get
                    Return MyBase.Properties
                End Get
            End Property
    
            <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
            <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
            <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
            <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
            Public NotInheritable Class PropertySet
                Inherits Global.Microsoft.LightSwitch.Details.Framework.Base.EntityPropertySet(Of __Product, __Product.DetailsClass)
    
                Public Sub New()
                    MyBase.New()
                End Sub
    
                Public ReadOnly Property Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Integer)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__Product.DetailsClass.PropertySetProperties.Id),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Integer))
                    End Get
                End Property
                
                Public ReadOnly Property RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Byte())
                    Get
                        Return TryCast(
                            MyBase.GetItem(__Product.DetailsClass.PropertySetProperties.RowVersion),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Byte()))
                    End Get
                End Property
                
                Public ReadOnly Property ProductName As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, String)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__Product.DetailsClass.PropertySetProperties.ProductName),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, String))
                    End Get
                End Property
                
                Public ReadOnly Property Price As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Decimal)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__Product.DetailsClass.PropertySetProperties.Price),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Decimal))
                    End Get
                End Property
                
                Public ReadOnly Property Tax As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.Tax)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__Product.DetailsClass.PropertySetProperties.Tax),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.Tax))
                    End Get
                End Property
                
                Public ReadOnly Property InventoryHeaders As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InventoryHeader)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__Product.DetailsClass.PropertySetProperties.InventoryHeaders),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InventoryHeader))
                    End Get
                End Property
                
                Public ReadOnly Property InvoiceDetails As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InvoiceDetail)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__Product.DetailsClass.PropertySetProperties.InvoiceDetails),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InvoiceDetail))
                    End Get
                End Property
                
                Public ReadOnly Property SalesOrderDetails As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__Product.DetailsClass.PropertySetProperties.SalesOrderDetails),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail))
                    End Get
                End Property
                
            End Class
    
            <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
            Public Interface IImplementation
                Inherits Global.Microsoft.LightSwitch.Internal.IEntityImplementation
    
                Shadows Property Id As Integer
                Shadows Property RowVersion As Byte()
                Shadows Property ProductName As String
                Shadows Property Price As Decimal
                Shadows Property Tax As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
                Shadows ReadOnly Property InventoryHeaders As Global.System.Collections.IEnumerable
                Shadows ReadOnly Property InvoiceDetails As Global.System.Collections.IEnumerable
                Shadows ReadOnly Property SalesOrderDetails As Global.System.Collections.IEnumerable
    
            End Interface
    
            <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
            <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
            <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
            Friend Class PropertySetProperties
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Integer).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Integer).Entry( _
                        "Id", _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Id_Stub, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Id_ComputeIsReadOnly, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Id_Validate, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Id_GetImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Id_SetImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Id_OnValueChanged)
                Private Shared Sub _Id_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __Product.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Integer).Data), d As __Product.DetailsClass, sf As Object)
                    c(d, d._Id, sf)
                End Sub
                Private Shared Function _Id_ComputeIsReadOnly(e As __Product) As Boolean
                    Dim result As Boolean = False
                    e.Id_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Id_Validate(e As __Product, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Id_Validate(r)
                End Sub
                Private Shared Function _Id_GetImplementationValue(d As __Product.DetailsClass) As Integer
                    Return d.ImplementationEntity.Id
                End Function
                Private Shared Sub _Id_SetImplementationValue(d As __Product.DetailsClass, v As Integer)
                    d.ImplementationEntity.Id = v
                End Sub
                Private Shared Sub _Id_OnValueChanged(e As __Product)
                    e.Id_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Byte()).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Byte()).Entry( _
                        "RowVersion", _
                        AddressOf __Product.DetailsClass.PropertySetProperties._RowVersion_Stub, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._RowVersion_ComputeIsReadOnly, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._RowVersion_Validate, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._RowVersion_GetImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._RowVersion_SetImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._RowVersion_OnValueChanged)
                Private Shared Sub _RowVersion_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __Product.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Byte()).Data), d As __Product.DetailsClass, sf As Object)
                    c(d, d._RowVersion, sf)
                End Sub
                Private Shared Function _RowVersion_ComputeIsReadOnly(e As __Product) As Boolean
                    Dim result As Boolean = False
                    e.RowVersion_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _RowVersion_Validate(e As __Product, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.RowVersion_Validate(r)
                End Sub
                Private Shared Function _RowVersion_GetImplementationValue(d As __Product.DetailsClass) As Byte()
                    Return d.ImplementationEntity.RowVersion
                End Function
                Private Shared Sub _RowVersion_SetImplementationValue(d As __Product.DetailsClass, v As Byte())
                    d.ImplementationEntity.RowVersion = v
                End Sub
                Private Shared Sub _RowVersion_OnValueChanged(e As __Product)
                    e.RowVersion_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly ProductName As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, String).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, String).Entry( _
                        "ProductName", _
                        AddressOf __Product.DetailsClass.PropertySetProperties._ProductName_Stub, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._ProductName_ComputeIsReadOnly, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._ProductName_Validate, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._ProductName_GetImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._ProductName_SetImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._ProductName_OnValueChanged)
                Private Shared Sub _ProductName_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __Product.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, String).Data), d As __Product.DetailsClass, sf As Object)
                    c(d, d._ProductName, sf)
                End Sub
                Private Shared Function _ProductName_ComputeIsReadOnly(e As __Product) As Boolean
                    Dim result As Boolean = False
                    e.ProductName_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _ProductName_Validate(e As __Product, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.ProductName_Validate(r)
                End Sub
                Private Shared Function _ProductName_GetImplementationValue(d As __Product.DetailsClass) As String
                    Return d.ImplementationEntity.ProductName
                End Function
                Private Shared Sub _ProductName_SetImplementationValue(d As __Product.DetailsClass, v As String)
                    d.ImplementationEntity.ProductName = v
                End Sub
                Private Shared Sub _ProductName_OnValueChanged(e As __Product)
                    e.ProductName_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Price As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Decimal).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Decimal).Entry( _
                        "Price", _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Price_Stub, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Price_ComputeIsReadOnly, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Price_Validate, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Price_GetImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Price_SetImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Price_OnValueChanged)
                Private Shared Sub _Price_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __Product.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Decimal).Data), d As __Product.DetailsClass, sf As Object)
                    c(d, d._Price, sf)
                End Sub
                Private Shared Function _Price_ComputeIsReadOnly(e As __Product) As Boolean
                    Dim result As Boolean = False
                    e.Price_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Price_Validate(e As __Product, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Price_Validate(r)
                End Sub
                Private Shared Function _Price_GetImplementationValue(d As __Product.DetailsClass) As Decimal
                    Return d.ImplementationEntity.Price
                End Function
                Private Shared Sub _Price_SetImplementationValue(d As __Product.DetailsClass, v As Decimal)
                    d.ImplementationEntity.Price = v
                End Sub
                Private Shared Sub _Price_OnValueChanged(e As __Product)
                    e.Price_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Tax As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.Tax).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.Tax).Entry( _
                        "Tax", _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Tax_Stub, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Tax_ComputeIsReadOnly, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Tax_Validate, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Tax_GetCoreImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Tax_GetImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Tax_SetImplementationValue, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Tax_Refresh, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._Tax_OnValueChanged)
                Private Shared Sub _Tax_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __Product.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.Tax).Data), d As __Product.DetailsClass, sf As Object)
                    c(d, d._Tax, sf)
                End Sub
                Private Shared Function _Tax_ComputeIsReadOnly(e As __Product) As Boolean
                    Dim result As Boolean = False
                    e.Tax_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Tax_Validate(e As __Product, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Tax_Validate(r)
                End Sub
                Private Shared Function _Tax_GetCoreImplementationValue(d as __Product.DetailsClass) As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
                    Return d.ImplementationEntity.Tax
                End Function
                Private Shared Function _Tax_GetImplementationValue(d as __Product.DetailsClass) As Global.LightSwitchApplication.Tax
                    Return d.GetImplementationValue(Of Global.LightSwitchApplication.Tax, Global.LightSwitchApplication.Tax.DetailsClass)(__Product.DetailsClass.PropertySetProperties.Tax, d._Tax)
                End Function
                Private Shared Sub _Tax_SetImplementationValue(d As __Product.DetailsClass, v As Global.LightSwitchApplication.Tax)
                    d.SetImplementationValue(__Product.DetailsClass.PropertySetProperties.Tax, d._Tax, Sub(i, ev) i.Tax = ev, v)
                End Sub
                Private Shared Sub _Tax_Refresh(d As __Product.DetailsClass)
                    d.RefreshNavigationProperty(__Product.DetailsClass.PropertySetProperties.Tax, d._Tax)
                End Sub
                Private Shared Sub _Tax_OnValueChanged(e As __Product)
                    e.Tax_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly InventoryHeaders As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InventoryHeader).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InventoryHeader).Entry( _
                        "InventoryHeaders", _
                        AddressOf __Product.DetailsClass.PropertySetProperties._InventoryHeaders_Stub, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._InventoryHeaders_GetReferencedEntities, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._InventoryHeaders_GetEntityCollection)
                Private Shared Sub _InventoryHeaders_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __Product.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InventoryHeader).Data), d As __Product.DetailsClass, sf As Object)
                    c(d, d._InventoryHeaders, sf)
                End Sub
                Private Shared Function _InventoryHeaders_GetReferencedEntities(d As __Product.DetailsClass) As Global.System.Collections.Generic.IEnumerable(Of Global.LightSwitchApplication.InventoryHeader)
                    Return d.GetReferencedEntities(Of Global.LightSwitchApplication.InventoryHeader, Global.LightSwitchApplication.InventoryHeader.DetailsClass)(__Product.DetailsClass.PropertySetProperties.InventoryHeaders, d._InventoryHeaders)
                End Function
                Private Shared Function _InventoryHeaders_GetEntityCollection(d As __Product.DetailsClass) As Global.System.Collections.IEnumerable
                    Return d.ImplementationEntity.InventoryHeaders
                End Function
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly InvoiceDetails As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InvoiceDetail).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InvoiceDetail).Entry( _
                        "InvoiceDetails", _
                        AddressOf __Product.DetailsClass.PropertySetProperties._InvoiceDetails_Stub, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._InvoiceDetails_GetReferencedEntities, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._InvoiceDetails_GetEntityCollection)
                Private Shared Sub _InvoiceDetails_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __Product.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InvoiceDetail).Data), d As __Product.DetailsClass, sf As Object)
                    c(d, d._InvoiceDetails, sf)
                End Sub
                Private Shared Function _InvoiceDetails_GetReferencedEntities(d As __Product.DetailsClass) As Global.System.Collections.Generic.IEnumerable(Of Global.LightSwitchApplication.InvoiceDetail)
                    Return d.GetReferencedEntities(Of Global.LightSwitchApplication.InvoiceDetail, Global.LightSwitchApplication.InvoiceDetail.DetailsClass)(__Product.DetailsClass.PropertySetProperties.InvoiceDetails, d._InvoiceDetails)
                End Function
                Private Shared Function _InvoiceDetails_GetEntityCollection(d As __Product.DetailsClass) As Global.System.Collections.IEnumerable
                    Return d.ImplementationEntity.InvoiceDetails
                End Function
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly SalesOrderDetails As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail).Entry( _
                        "SalesOrderDetails", _
                        AddressOf __Product.DetailsClass.PropertySetProperties._SalesOrderDetails_Stub, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._SalesOrderDetails_GetReferencedEntities, _
                        AddressOf __Product.DetailsClass.PropertySetProperties._SalesOrderDetails_GetEntityCollection)
                Private Shared Sub _SalesOrderDetails_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __Product.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail).Data), d As __Product.DetailsClass, sf As Object)
                    c(d, d._SalesOrderDetails, sf)
                End Sub
                Private Shared Function _SalesOrderDetails_GetReferencedEntities(d As __Product.DetailsClass) As Global.System.Collections.Generic.IEnumerable(Of Global.LightSwitchApplication.SalesOrderDetail)
                    Return d.GetReferencedEntities(Of Global.LightSwitchApplication.SalesOrderDetail, Global.LightSwitchApplication.SalesOrderDetail.DetailsClass)(__Product.DetailsClass.PropertySetProperties.SalesOrderDetails, d._SalesOrderDetails)
                End Function
                Private Shared Function _SalesOrderDetails_GetEntityCollection(d As __Product.DetailsClass) As Global.System.Collections.IEnumerable
                    Return d.ImplementationEntity.SalesOrderDetails
                End Function
    
            End Class
    
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Integer).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Byte()).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _ProductName As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, String).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Price As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __Product, __Product.DetailsClass, Decimal).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Tax As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.Tax).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _InventoryHeaders As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InventoryHeader).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _InvoiceDetails As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.InvoiceDetail).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _SalesOrderDetails As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __Product, __Product.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail).Data
            
        End Class
    
        #End Region
    
    End Class
    
    #End Region
End Namespace
